package cn.com.infosec.mobile.android.xlog.printer;

import android.support.annotation.Keep;
import android.util.Log;

@Keep
public class AndroidPrinter implements Printer {
   static final int DEFAULT_MAX_CHUNK_SIZE = 4000;
   private boolean autoSeparate;
   private int maxChunkSize;

   public AndroidPrinter() {
      this(false, 4000);
   }

   public AndroidPrinter(boolean autoSeparate) {
      this(autoSeparate, 4000);
   }

   public AndroidPrinter(int maxChunkSize) {
      this(false, maxChunkSize);
   }

   public AndroidPrinter(boolean autoSeparate, int maxChunkSize) {
      this.autoSeparate = autoSeparate;
      this.maxChunkSize = maxChunkSize;
   }

   static int adjustEnd(String msg, int start, int originEnd) {
      if (originEnd == msg.length()) {
         return originEnd;
      } else if (msg.charAt(originEnd) == '\n') {
         return originEnd;
      } else {
         for(int var3 = originEnd - 1; start < var3; --var3) {
            if (msg.charAt(var3) == '\n') {
               return var3;
            }
         }

         return originEnd;
      }
   }

   public void println(int logLevel, String tag, String msg) {
      int var4 = msg.length();
      int var5 = 0;

      while(var5 < var4) {
         if (msg.charAt(var5) == '\n') {
            ++var5;
         } else {
            int var6 = Math.min(var5 + this.maxChunkSize, var4);
            int var7;
            if (this.autoSeparate) {
               if ((var7 = msg.indexOf(10, var5)) == -1) {
                  var7 = var6;
               }
            } else {
               var7 = adjustEnd(msg, var5, var6);
            }

            String var8 = msg.substring(var5, var7);
            this.printChunk(logLevel, tag, var8);
            var5 = var7;
         }
      }

   }

   void printChunk(int logLevel, String tag, String msg) {
      Log.println(logLevel, tag, msg);
   }
}
